import { IRequest } from './types';
export type CorsOptions = {
    credentials?: true;
    origin?: boolean | string | string[] | RegExp | ((origin: string) => string | void);
    maxAge?: number;
    allowMethods?: string | string[];
    allowHeaders?: any;
    exposeHeaders?: string | string[];
};
export type Preflight = (request: IRequest) => Response | void;
export type Corsify = (response: Response, request?: IRequest) => Response;
export type CorsPair = {
    preflight: Preflight;
    corsify: Corsify;
};
export declare const cors: (options?: CorsOptions) => {
    corsify: (response: Response, request?: Request) => Response;
    preflight: (request: Request) => Response | undefined;
};
